<?php
/*
check
{code: 1, version: '1.1.1', message: '发现新版本'}
{code: 0, version: '1.1.1', message: '最新版本无需更新'}

update
{code: 1, version: '1.1.1', message: '更新完成'}
{code: 0, version: '1.1.1', message: '最新版本无需更新'}
*/


$versionfile = 'version.txt';
$old_version = file_exists($versionfile) ? file_get_contents($versionfile) : 0;

if (!isset($_GET['type'])) {
    die('no access');
}

$action = $_GET['type'];

if ($action == 'check') {
    check();
}
if ($action == 'update') {
    update();
}

//检查版本
function check()
{
    $res = getVersion();
	$result = $res['result'];
    global $old_version;

    if ($old_version != $result['version']) {
        resp(1, $result['version'], '发现新版本');
    } else {
        resp(0, $result['version'], '最新版本无需更新');
    }
}

//--获取版本信息
function getVersion()
{
    $res = json_decode(file_get_contents('http://request.uois.cn/interface/getVersion'), 1);
    if ($res['code'] == 1) {
        return $res;
    } else {
        resp(0, false, '未获取到版本信息');
        exit;
    }
}

//更新版本信息
function update()
{
	global $versionfile;
	global $old_version;
	//解压目录
	$zipdir = '..';

    $res = getVersion();
	$result = $res['result'];
    $new_version = $result['version'];
    $updateUrl = $result['updateUrl'];

	$folderList = $res['folderList'];
    //1 还是比对
    if ($old_version != $new_version) {
        //2 下载文件
        $zipfile = time() . '.zip';
        $str = file_get_contents($updateUrl);
        file_put_contents($zipfile, $str);

        //3 删除 folderList
		foreach($folderList as $dir ){
			deldir(rtrim($zipdir.'/'.$dir,'/'));
		}
        //4解压 到根目录
        unzip($zipfile, $zipdir);
        unlink($zipfile);

        //5改写txt里的版本号
        file_put_contents($versionfile, $new_version);
        //6给我返回结果
        resp(1, $new_version, '更新完成');
    } else {
        //6给我返回结果
        resp(0, $old_version, '最新版本无需更新');
    }

}


function resp($code, $version, $message)
{
    $rr = [
        'code' => $code,
        'version' => $version,
        'message' => $message
    ];
    $json = json_encode($rr,JSON_UNESCAPED_UNICODE);
    die($json);
}


function unzip($filePath, $path)
{
    if (empty($path) || empty($filePath)) {
        return false;
    }

    $zip = new ZipArchive();

    if ($zip->open($filePath) === true) {
        $zip->extractTo($path);
        $zip->close();
        return true;
    } else {
        return false;
    }
}

function deldir($path)
{
    if (is_dir($path)) {
        $p = scandir($path);
        foreach ($p as $val) {
            if ($val != "." && $val != "..") {
                if (is_dir(rtrim($path, '/') . '/' . $val)) {
                    deldir(rtrim($path, '/') . '/' . $val . '/');
                    @rmdir(rtrim($path, '/') . '/' . $val . '/');

                } else {
                    unlink(rtrim($path, '/') . '/' . $val);
                }
            }
        }
       @rmdir(rtrim($path, '/') );
    }
}